## deal.ii 7.0.0

=== lib/Makefile ===
# $Id: Makefile 23048 2010-12-21 04:15:20Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 2002

D = ..

# get options which hold for all files of the project
include $D/common/Make.global_options


default:
	@echo There is no default target in this directory


######################### EXTERNAL LINK TARGETS ###################
# link in external libs, if any
external-links: external-links-petsc

ifeq ($(USE_CONTRIB_PETSC),yes)

  # PETSc has the nasty habit of putting debug and optimized builds into
  # different directories, but naming the respective libraries the same.
  # Since one doesn't want to always set and reset $LD_LIBRARY_PATH when
  # one switches from debug to optimized mode, they pass -Wl,-rpath to
  # the linker line. This is not really portable, and it has the additional
  # drawback that one has to pass different linker flags for debug and
  # optimized mode. The latter is a problem with our present build system,
  # which allows to use different libraries, but doesn't take into account
  # that one may want to pass different $LDFLAGS.
  #
  # To avoid such hassle, we build some kind of convenience library: a shared
  # library that has no content, but contains references to all the different
  # PETSc libraries, and we build one for debug and one for optimized mode.
  # We can't really get around the use of -Wl,-rpath, but at least we
  # have now centralized this part to one single place, and are back to where
  # we want to be: have different libraries for debug and optimized mode,
  # but in the same directory. And, voila, our build system works again :-)
  #
  # There is one gotcha: PETSc has a habit of making incompatible changes by
  # simply changing the names of libraries between different versions. That
  # really is too bad, so we have to conditionalize things.
ifeq ($(DEAL_II_PETSC_VERSION_MINOR),1)
  xlib-ksp=libpetscsles
else
  xlib-ksp=libpetscksp
endif
  # This is how it is done. Starting with PETSc versions 2.3.*:
ifeq ($(DEAL_II_PETSC_VERSION_MAJOR),2)
  xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
  xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
else
  # which is the same for PETSc 3.0.0:
  ifeq ($(DEAL_II_PETSC_VERSION_MAJOR)$(DEAL_II_PETSC_VERSION_MINOR),30)
    xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  else
    # but after that (petsc-3.1++), we can use the simpler PETSc
    # default "--with-single-library=1" like this:
    xlib.g = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  endif
endif

ifeq ($(enable-shared),yes)

  external-links-petsc: libpetscall.g$(shared-lib-suffix) libpetscall$(shared-lib-suffix)

  libpetscall.g$(shared-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall.g) $(call DEAL_II_ADD_SONAME,petscall.g) $(xlib.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall.g) $@

  libpetscall$(shared-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall) $(call DEAL_II_ADD_SONAME,petscall)  $(xlib.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall) $@

else

  # make static libraries. ensure that they are built one after the other because
  # both create temporary files with the same name
  external-links-petsc:
	@$(MAKE) libpetscall.g$(static-lib-suffix)
	@$(MAKE) libpetscall$(static-lib-suffix)

  # As I don't know how to merge archives, here's a workaround: Extract each of
  # the archives and append the object files to the libpetsc archive. Do the
  # same for debug and optimized mode.
  libpetscall.g$(static-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.g) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall.g$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall.g$(static-lib-suffix)

  libpetscall$(static-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.o) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall$(static-lib-suffix)
endif


else
  external-links-petsc:
endif



######################### CLEAN TARGETS ###################
# clean everything
clean: clean-objects clean-bin

# only clean object files, not libraries and executables
clean-objects:  clean-debug clean-optimized \
		clean-contrib


# clean targets for the individual subdirectories. remove
# object files and template instantiation files.
# extract dir name from target
clean-debug clean-optimized:
	-cd $(@:clean-%=%) ; rm -f *.$(OBJEXT) *.ti *.ii

clean-contrib:
	-rm contrib/*/*.$(OBJEXT)
	-rm -r contrib/tbb/*debug
	-rm -r contrib/tbb/*release
	-rm libtbb*

clean-bin:
	-rm bin/detached_ma27
	-rm bin/dealii_parameter_gui

distclean: clean
	-rm -f lib* bin/*

.PHONY: clean clean-objects
.PHONY: clean-base clean-lac clean-1d clean-2d clean-3d
.PHONY: clean-contrib
.PHONY: external-links external-links-petsc

=== source/Makefile ===
# $Id: Makefile 23068 2010-12-22 22:24:43Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 1998, 1999, 2000, 2001, 2002, 2010


ifneq ($(CLEAN),yes)

# deal.II top level directory
D=..


# get options which hold for all files of the project
include $D/common/Make.global_options

# top level targets
default all: debug optimized


# list the directories and the various kinds of files, the ones with the
# largest compile jobs first so that 'make -j N' saturates many processors
# also towards the end of compiling (e.g. numerics/vectors.cc takes several
# minutes to compile...)
all-dirs      := numerics fe dofs lac base grid hp multigrid distributed

cc-files      := $(shell for i in $(all-dirs) ; do echo $D/source/$$i/*.cc ; done)
h-files       := $(sort $(shell echo $D/include/deal.II/*/*.h))

inst-in-files := $(shell echo */*.inst.in)
inst-files    := $(inst-in-files:%.in=%)


# build unique object file names
tmp1               := $(shell echo $(cc-files) | $(PERL) -pi -e 's,$D/source/,,g; s,/,_,g;')
tmp-o-files-indep  := $(addprefix $(LIBDIR)/optimized/, $(tmp1:.cc=.$(OBJEXT)) )
tmp-go-files-indep := $(addprefix $(LIBDIR)/debug/, $(tmp1:.cc=.$(OBJEXT)))

o-files  := $(tmp-o-files-indep)
go-files := $(tmp-go-files-indep)


debug: $(LIBDIR)/libdeal_II.g$(lib-suffix)
optimized: $(LIBDIR)/libdeal_II$(lib-suffix)



# rules how to generate object files from source files.
$(LIBDIR)/debug/%.$(OBJEXT) :
	@echo "======================debug======$(MT)== $(<:$D/source/%=%)"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
$(LIBDIR)/optimized/%.$(OBJEXT) :
	@echo "======================optimized==$(MT)== $(<:$D/source/%=%)"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@



%.inst : %.inst.in $D/common/template-arguments
	@echo "===================================== $(@F)"
	@$D/common/scripts/expand_instantiations $D/common/template-arguments < $< > $@



# there are extra .o file for the function parser and umfpack that we
# need to link into out library
ifeq ($(enable-parser),yes)
  extra-o-files   := $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
  extra-g.o-files := $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
endif

ifeq ($(USE_CONTRIB_UMFPACK),yes)
  umfpack-files   := $(sort $(shell echo $(LIBDIR)/contrib/umfpack/*.$(OBJEXT)))
  extra-o-files   += $(umfpack-files)
  extra-g.o-files += $(umfpack-files)
endif



# in general, when linking shared libraries, we will want to link with
# the underlying libs as well. AIX even requires this. on the other
# hand, on DEC OSF with CXX this will fail with duplicate symbols, so
# make sure that it doesn't happen on that system and that compiler
ifneq ($(GXX-VERSION),compaq_cxx)
  # if we use HSL, then we need to link against libhsl.so.
  ifeq ($(USE_CONTRIB_HSL),yes)
    deplibs.g += $(lib-contrib-hsl)
    deplibs.o += $(lib-contrib-hsl)
  endif

  # same with PETSC
  ifeq ($(USE_CONTRIB_PETSC),yes)
    deplibs.g += $(lib-contrib-petsc.g)
    deplibs.o += $(lib-contrib-petsc.o)
  endif

  # same with SLEPC
  ifeq ($(USE_CONTRIB_SLEPC),yes)
    deplibs.g += $(lib-contrib-slepc)
    deplibs.o += $(lib-contrib-slepc)
  endif

  # same with TRILINOS
  ifeq ($(USE_CONTRIB_TRILINOS),yes)
    deplibs.g += $(lib-contrib-trilinos)
    deplibs.o += $(lib-contrib-trilinos)
  endif

  # same with MUMPS
  ifeq ($(USE_CONTRIB_MUMPS),yes)
    deplibs.g += $(lib-contrib-mumps)
    deplibs.o += $(lib-contrib-mumps)
  endif

  # and METIS
  ifeq ($(USE_CONTRIB_METIS),yes)
    deplibs.g += $(lib-contrib-metis)
    deplibs.o += $(lib-contrib-metis)
  endif

  # also link with TBB
  ifeq ($(enable-threads),yes)
    deplibs.g += $D/lib/libtbb_debug$(shared-lib-suffix)
    deplibs.o += $D/lib/libtbb$(shared-lib-suffix)
  endif

  # and p4est
  ifeq ($(USE_CONTRIB_P4EST),yes)
    deplibs.g += $(DEAL_II_P4EST_DIR)/DEBUG/lib/libp4est$(shared-lib-suffix) \
                 $(DEAL_II_P4EST_DIR)/DEBUG/lib/libsc$(shared-lib-suffix) \
		 $(call DEAL_II_RPATH,$(DEAL_II_P4EST_DIR)/DEBUG/lib)
    deplibs.o += $(DEAL_II_P4EST_DIR)/FAST/lib/libp4est$(shared-lib-suffix) \
                 $(DEAL_II_P4EST_DIR)/FAST/lib/libsc$(shared-lib-suffix) \
		 $(call DEAL_II_RPATH,$(DEAL_II_P4EST_DIR)/FAST/lib)
  endif

  # for cygwin and darwin, also llapack and such are necessary
  # we better link all libraries mentioned in $(LIBS)
  ifneq ($(findstring cygwin,$(TARGET))$(findstring darwin,$(TARGET)),)
    deplibs.g += $(LIBS)
    deplibs.o += $(LIBS)
  endif

else
  deplibs.g =
  deplibs.o =
endif


# rules how to make the libraries themselves
$(LIBDIR)/libdeal_II.g$(static-lib-suffix): $(go-files)
	@echo "=====deal.II==========debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files) $(extra-g.o-files)
	@$(RANLIB) $@
$(LIBDIR)/libdeal_II$(static-lib-suffix): $(o-files)
	@echo "=====deal.II==========optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files) $(extra-o-files)
	@$(RANLIB) $@


$(LIBDIR)/libdeal_II.g$(shared-lib-suffix): $(go-files)
	@echo "=====deal.II==========debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II.g) $(call DEAL_II_ADD_SONAME,deal_II.g) $(go-files) $(extra-g.o-files) $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II.g) $@

$(LIBDIR)/libdeal_II$(shared-lib-suffix): $(o-files)
	@echo "=====deal.II==========optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II) $(call DEAL_II_ADD_SONAME,deal_II) $(o-files) $(extra-o-files) $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II) $@



# generate a file that contains prototypes for BLAS and LAPACK functions
../include/deal.II/lac/lapack_templates.h: ../include/deal.II/lac/lapack_templates.h.in \
						$D/common/scripts/lapack_templates.pl
	@echo ===================================== Remaking $@
	@$(PERL) $D/common/scripts/lapack_templates.pl ../include/deal.II/lac/lapack_templates.h.in > $@


# A rule to make sure the various */Makefile.dep files have the right
# dependencies on their source files. Use the opportunity to also ensure that
# .inst and the lapack file are built before everything else
Makefile.dep: $(inst-files) ../include/deal.II/lac/lapack_templates.h \
		$(cc-files)
	@echo "===================================== Remaking $@"
	@for i in $(all-dirs) ; do \
		echo $$i/Makefile.dep: $$i/*.cc  \
					$(h-files) \
					Makefile \
					$D/common/Make.global_options ; \
	 done >> $@
	@echo "lac/Makefile.dep: $D/include/deal.II/lac/lapack_templates.h.in \
				 $D/include/deal.II/lac/lapack_templates.h.in" \
	 >> $@
include Makefile.dep


# Rule to generate the dependency files, one for each source
# directory. These file are automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion below.
#
# If the command fails, then remove Makefile.dep again and fail
%/Makefile.dep:
	@echo "===================================== Remaking $@"
	@(($D/common/scripts/make_dependencies -n $(INCLUDE) "-B\$$(LIBDIR)" \
			$(filter $D/source/$(dir $@)%, $(cc-files)) \
		| $(PERL) -pe 's!LIBDIR\)/(debug|optimized)/(.*):!LIBDIR)/$$1/$(@:%/Makefile.dep=%)_$$2:!g;' \
	  ) > $@) \
	 || (rm -f $@ ; false)


# include all the dependencies
include $(addsuffix /Makefile.dep, $(all-dirs))

endif



################### some clean-up rules

clean:
	-rm -f Makefile.dep *~ */*~ */*/*~ */Makefile.dep source/*/*.inst \
		$D/lib/{debug,optimized}/*.o


###################

.PHONY: default all debug optimized TAGS
.PHONY: clean

=== common/scripts/Makefile ===
# $Id: Makefile 21481 2010-07-13 04:55:47Z kanschat $
# Copyright W. Bangerth, 2003


# deal.II top level directory
D=../..

include $D/common/Make.global_options

default: make_dependencies$(EXEEXT) expand_instantiations$(EXEEXT) \
         report_features$(EXEEXT)


# rules to generate the program. let is be dependent on the global flags for
# the following reason: if you go to a different system, but keep with the
# same directory, you get into trouble because make_dependencies is not
# deleted by "make clean"; following this, we generate empty Makefile.dep's
# because we can't run the executable. So better be careful and regenerate
# make_dependencies whenever we think it may be beneficial
make_dependencies$(EXEEXT) : make_dependencies.cc $D/common/Make.global_options
	@echo ============================ Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

expand_instantiations$(EXEEXT) : expand_instantiations.cc $D/common/Make.global_options
	@echo ============================ Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

report_features$(EXEEXT) : report_features.cc $D/common/Make.global_options
	@echo ============================ Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

clean:
	-rm -f make_dependencies$(EXEEXT)
	-rm -f make_dependencies.o
	-rm -f expand_instantiations$(EXEEXT)
	-rm -f expand_instantiations.o

.PHONY: clean

=== examples/step-1/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = step-1

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@" $@
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-15/Makefile ===
# Makefile,v 1.7 2002/11/11 21:29:46 wolf Exp


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-16/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $

# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-17/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options

################################################################ 
# This example program will only work if PETSc is installed. If this
# is not the case, then simply redefine the main targets to do nothing
#
# The same holds true if we use threads: PETSc and threads doesn't
# seem to work well together...
ifneq ($(USE_CONTRIB_PETSC)$(enable-threads),yesno)
  ifneq ($(USE_CONTRIB_PETSC),yes)
default run clean:
	@echo
	@echo "===========================================================" 
	@echo "=   This program cannot be compiled without PETSc. Make   ="
	@echo "=   sure you have PETSc installed and detected during     ="
	@echo "=   configuration of deal.II                              ="
	@echo "==========================================================="
	@echo
  else
default run clean:
	@echo
	@echo "===========================================================" 
	@echo "=   PETSc can not be used when running programs on        ="
	@echo "=   multiple threads. Make sure you have specified the    ="
	@echo "=   --disable-threads flag upon configuration of deal.II  ="
	@echo "==========================================================="
	@echo
  endif
else
#
################################################################




# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep


endif  # CONTRIB_USE_PETSC

=== examples/step-18/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options

################################################################
# This example program will only work if PETSc is installed. If this
# is not the case, then simply redefine the main targets to do nothing
#
# The same holds true if we use threads: PETSc and threads doesn't
# seem to work well together...
ifneq ($(USE_CONTRIB_PETSC)$(enable-threads),yesno)
  ifneq ($(USE_CONTRIB_PETSC),yes)
default run clean:
	@echo
	@echo "==========================================================="
	@echo "=   This program cannot be compiled without PETSc. Make   ="
	@echo "=   sure you have PETSc installed and detected during     ="
	@echo "=   configuration of deal.II                              ="
	@echo "==========================================================="
	@echo
  else
default run clean:
	@echo
	@echo "==========================================================="
	@echo "=   PETSc can not be used when running programs on        ="
	@echo "=   multiple threads. Make sure you have specified the    ="
	@echo "=   --disable-threads flag upon configuration of deal.II  ="
	@echo "==========================================================="
	@echo
  endif
else
#
################################################################




# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep


endif  # CONTRIB_USE_PETSC

=== examples/step-24/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


################################################################
# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-31/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options

################################################################ 
# This example program will only work if Trilinos is installed. If this
# is not the case, then simply redefine the main targets to do nothing
ifneq ($(USE_CONTRIB_TRILINOS),yes)
default run clean:
	@echo
	@echo "===========================================================" 
	@echo "=   This program cannot be compiled without Trilinos. Make="
	@echo "=   sure you have Trilinos installed and detected during  ="
	@echo "=   configuration of deal.II                              ="
	@echo "==========================================================="
	@echo

else
#
################################################################




# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)



# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@



# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep


endif  # USE_CONTRIB_TRILINOS

=== examples/step-33/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The fourth field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2



# The last field specifies the name of the input file that passes the
# parameters to the program.
run-parameters = input.prm





#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options

################################################################ 
# This example program will only work if Trilinos is installed. If this
# is not the case, then simply redefine the main targets to do nothing
ifneq ($(USE_CONTRIB_TRILINOS),yes)
default run clean:
	@echo
	@echo "===========================================================" 
	@echo "=   This program cannot be compiled without Trilinos. Make="
	@echo "=   sure you have Trilinos installed and detected during  ="
	@echo "=   configuration of deal.II                              ="
	@echo "==========================================================="
	@echo

else
#
################################################################




# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT) $(run-parameters)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep


endif  # CONTRIB_USE_TRILINOS

=== examples/step-34/Makefile ===
# $Id: Makefile 22601 2010-11-04 03:26:19Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = $(basename $(shell echo step-*.cc))

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


################################################################
# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== debian/changelog ===
deal.ii (7.0.0-3) unstable; urgency=low

  * Made perl script in -dev package executable.
  * Split install target, cleaned up others, removed build-indep from build
    (closes: #637845).

 -- "Adam C. Powell, IV" <hazelsct@debian.org>  Mon, 12 Dec 2011 21:16:56 -0500

deal.ii (7.0.0-2) unstable; urgency=low

  * Changed doxygen/texlive dependencies to doxygen-latex (closes: #616208).
  * Moved report_features binary from -dev package scripts directory to shlib
    package lib/deal.II-$(version) to eliminate lintian error.
  * Fixed PETSc libraries problem in Make.global_options.
  * Sacado test in step-33 works, even despite bug 637352 (closes: #530930).

 -- "Adam C. Powell, IV" <hazelsct@debian.org>  Thu, 11 Aug 2011 14:58:45 -0400

deal.ii (7.0.0-1) unstable; urgency=low

  [ Christophe Trophime ]
  * New upstream (closes: #618575).

  [ Nuno Sucena Almeida ]
  * Transitioned package to version 7.0.0, including forward-porting all
    patches.
  * Rebuilt libraries link properly with new Trilinos libs (closes: #630662).

  [ Adam C. Powell, IV ]
  * Bumped Standards-Version
  * Updated libdeal.ii-dev shared library dependency
  * Removed timestamps from patches to avoid spurious timestamp-update patches
    for future upgrades.
  * Detect Trilinos version properly.
  * Save upstream configure and config.h.in and restore them in clean target.
  * Added qmake and libqt4-dev to Build-Depends.
  * Build system updates to eliminate double build and provide needed targets.

 -- "Adam C. Powell, IV" <hazelsct@debian.org>  Sun, 07 Aug 2011 20:01:59 -0400

=== debian/control ===
Source: deal.ii
Section: devel
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7), quilt, automake, autoconf, gfortran, zlib1g-dev,
  libblas-dev, liblapack-dev, libpetsc3.1-dev, libslepc3.1-dev,
  libtrilinos-dev (>=9.0.2.dfsg-4), libscotchmetis-dev (>= 5.1.4.dfsg-2),
  libsuitesparse-dev, libnetcdf-dev, libboost-dev, libboost-graph-dev,
  libboost-python-dev, libtbb-dev, libtbb2-dbg, qt4-qmake, libqt4-dev
Build-Depends-Indep: doxygen-latex, graphviz, ghostscript
Vcs-Git: git://git.debian.org/git/debian-science/packages/deal.ii.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/

Package: libdeal.ii-dbg7.0.0
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the debugging shared libraries.

Package: libdeal.ii-dbg
Architecture: all
Section: debug
Depends: libdeal.ii-dbg7.0.0 (>= ${source:Version}), ${misc:Depends}
Recommends: libdeal.ii-dev (= ${source:Version}), libtbb2-dbg
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using debugging shared libraries.

Package: libdeal.ii7.0.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the optimized shared libraries.

Package: libdeal.ii-dev
Architecture: all
Section: libdevel
Depends: libdeal.ii7.0.0 (>= ${source:Upstream-Version}), libdeal.ii7.0.0 (<< ${source:Upstream-Version}+1~), libblas-dev, liblapack-dev, libpetsc3.1-dev, libslepc3.1-dev, libtrilinos-dev (>=9.0.2.dfsg-3), libscotchmetis-dev (>= 5.1.4.dfsg-2), libsuitesparse-dev, libnetcdf-dev, libboost-dev, libtbb-dev, ${misc:Depends}
Suggests: libdeal.ii-dbg, deal.ii-doc, deal.ii-examples
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using optimized shared libraries.

Package: deal.ii-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the documentation.

Package: deal.ii-examples
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: libdeal.ii-dev
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the tutorial examples' source code.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

package=deal.ii
version=7.0.0

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

patch: stamp-patch
stamp-patch:
	if [ ! -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2; \
	fi
	if [ ! -e configure.upstream ]; then \
	  cp -a configure configure.upstream; \
	  cp -a include/deal.II/base/config.h.in include/deal.II/base/config.h.in.upstream; \
	fi
	touch $@

clean:
	dh_testdir
	if [ -e common/Make.global_options ]; then $(MAKE) distclean; fi
	if [ -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2; \
	  rm -rf .pc; \
	fi
	if [ -e configure.upstream ]; then \
	  rm -f configure include/deal.II/base/config.h.in; \
	  mv configure.upstream configure; \
	  mv include/deal.II/base/config.h.in.upstream include/deal.II/base/config.h.in; \
	fi
	rm -f stamp-* install-*
	rm -f config.status config.log
	rm -f contrib/config.status contrib/config.log
	rm -f contrib/utilities/config.status contrib/utilities/config.log

	rm -f common/Make.global_options common/Makefile.template common/Make.global_options
	rm -f common/template-arguments common/scripts/make_dependencies.pl
	rm -f common/scripts/make_todo.pl common/scripts/report_features
	rm -f Version contrib/Makefile contrib/configure contrib/utilities/Makefile contrib/utilities/configure
	rm -f include/deal.II/base/config.h
	rm -f include/deal.II/lac/lapack_templates.h
	rm -f doc/doxygen/header.html doc/doxygen/header.tex
	rm -f doc/doxygen/header.136 doc/doxygen/options.136
	rm -f doc/doxygen/tutorial/toc.html
	rm -f doc/doxygen/Makefile
	rm -f doc/development/makefile.rules.html
	rm -f doc/title.html
	rm -rf lib/contrib
	rm -rf lib/debug lib/optimized lib/bin

	rm -f doc/Makefile doc/doxygen/doxygen.log doc/doxygen/*.dox
	dh_clean

stamp-configure: stamp-patch
	dh_testdir
	aclocal --force
	autoreconf -i -v
	CXX=mpicxx CC=mpicc PETSC_DIR=/usr/lib/petsc PETSC_ARCH=`petscarch` \
	  SLEPC_DIR=/usr/lib/slepc SLEPC_ARCH=linux-gnu-c-opt \
	  ./configure --prefix=/usr --enable-parser --enable-multithreading \
	  --enable-shared \
	  --with-boost-libs=/usr/lib --with-boost-include=/usr/include/boost \
	  --with-blas --with-lapack \
	  --with-umfpack-libs=/usr/lib --with-umfpack-include=/usr/include/suitesparse \
	  --with-metis-libs=/usr/lib --with-metis-include=/usr/include/metis/ \
	  --with-trilinos-libs=/usr/lib --with-trilinos-include=/usr/include/trilinos \
	  --with-netcdf-libs=/usr/lib --with-netcdf-include=/usr/include
	touch $@

build: build-arch
build-arch: stamp-build-arch
stamp-build-arch: stamp-configure
	dh_testdir
# Move aside Make.global_options and replace it with something temporary
	mv common/Make.global_options common/Make.global_options.orig
	sed 's/$$(LIBDIR)\/lib/-L$$(LIBDIR) -l/' < common/Make.global_options.orig \
	  | sed 's/.g$$(lib-suffix)/.g/' | sed 's/call$$(lib-suffix)/call/' \
	  | sed 's/hsl$$(lib-suffix)/hsl/' | sed 's/ase$$(lib-suffix)/ase/' \
	  | sed 's/lac$$(lib-suffix)/lac/' | sed 's/_1d$$(lib-suffix)/_1d/' \
	  | sed 's/_2d$$(lib-suffix)/_2d/' | sed 's/_3d$$(lib-suffix)/_3d/' \
	  > common/Make.global_options
	$(MAKE) $(MAKEFLAG) all
	touch $@

build-indep: stamp-build-indep
stamp-build-indep: stamp-configure
	$(MAKE) $(MAKEFLAG) online-doc
	touch $@

install-arch: build-arch
# Distribute the libs
	install -d debian/libdeal.ii-dbg$(version)/usr/lib
	mv lib/*.g.so.$(version) debian/libdeal.ii-dbg$(version)/usr/lib/
	install -d debian/libdeal.ii$(version)/usr/lib
	mv lib/*.so.$(version) debian/libdeal.ii$(version)/usr/lib/
# There are a couple of binaries in common/scripts which belong in $(version)
	install -d debian/libdeal.ii$(version)/usr/lib/deal.II-$(version)
	cp -a common/scripts/expand_instantiations \
	    common/scripts/make_dependencies common/scripts/report_features \
	    debian/libdeal.ii$(version)/usr/lib/deal.II-$(version)/ ; \
	fi
	touch $@

install-indep: build-indep
# Put the shlib links and includes in -dev
	install -d debian/libdeal.ii-dbg/usr/lib
	mv lib/*.g.so debian/libdeal.ii-dbg/usr/lib/
	install -d debian/libdeal.ii-dev/usr/lib
	mv lib/*.so debian/libdeal.ii-dev/usr/lib/
	install -d debian/libdeal.ii-dev/usr/include/deal.II
	cp -a include/deal.II/* \
	    debian/libdeal.ii-dev/usr/include/deal.II/
# Install the common files, removing the binaries that go in $(version)
	install -d debian/libdeal.ii-dev/usr/share/deal.II
	cp -a common/* debian/libdeal.ii-dev/usr/share/deal.II
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/scripts/report_features \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/expand_instantiations
# Link to scripts in $(version) and make "make_todo.pl" executable
	ln -s ../../../lib/deal.II-$(version)/expand_instantiations \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/expand_instantiations
	ln -s ../../../lib/deal.II-$(version)/make_dependencies \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies
	ln -s ../../../lib/deal.II-$(version)/report_features \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/report_features
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/scripts/*.cc \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_tarfile.sh
	chmod +x debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_todo.pl
# Fix Make.global_options
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options*
	sed "s/`echo $(CURDIR) | sed 's/\//\\\\\//g'`/\/usr/" \
	  < common/Make.global_options.orig | \
	  sed 's/deal.II\/include/include\/deal.II/' \
	  > debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options
# Remove backup files
	rm -f debian/libdeal.ii-dev/usr/include/deal.II/base/config.h.in~
	touch $@

binary-indep: install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
#	dh_install -i
#	dh_movefiles -i
	dh_installdocs -i
	rm -rf debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/doc
# Fix example Makefiles
	for mfile in `ls debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/Makefile`; do \
	  mv $$mfile $$mfile.in; \
	  sed 's/$$D\/common/$$D/' < $$mfile.in | \
	    sed 's/$$D\/include\/deal\.II/\/usr\/include\/deal.II/' | \
	    sed 's/$$D/\/usr\/share\/deal.II/' | \
	    sed 's/debug-mode = on/debug-mode = off/' | \
	    grep -v 'D = ' > $$mfile; \
	  rm -f $$mfile.in; \
	done
	dh_installchangelogs -i
	dh_compress -i -XMakefile -Xcc -Xinp
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install-arch
	dh_testdir -a
	dh_testroot -a
	dh_installdirs -a
#	dh_install -a
#	dh_movefiles -a
	install -d debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides
	install -m 644 debian/libdeal.ii-dbg$(version).overrides \
	  debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides/libdeal.ii-dbg$(version)
	dh_installdocs -a
	dh_installchangelogs -a
	dh_strip -a -X.g
	dh_makeshlibs -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean
